public class Client extends Personne
{
   private static final float
      DETTE_DFAUT = 0.0f;
   private String m_Adresse;
   private float m_MontantEnSouffrance;

   public void SetAdresse (final String Adresse)
      throws Exception
   {
      if (Adresse == null)
         throw new Exception ("Adresse nulle (interdit)");
      SetAdresseBrut (Adresse);
   }
   private void SetAdresseBrut (final String Adresse)
   {
      m_Adresse = Adresse;
   }
   public String GetAdresse ()
   {
      return m_Adresse;
   }

   public void SetMontantEnSouffrance (final float MontantEnSouffrance)
      throws Exception
   {
      if (MontantEnSouffrance < 0)
         throw new Exception ("Dette ngative (illgal)");
      SetMontantEnSouffranceBrut (MontantEnSouffrance);
   }
   private void SetMontantEnSouffranceBrut (final float MontantEnSouffrance)
   {
      m_MontantEnSouffrance = MontantEnSouffrance;
   }
   public float GetMontantEnSouffrance ()
   {
      return m_MontantEnSouffrance;
   }
   //
   // La comparaison de rels doit tenir compte des imprcisions
   // normales dans les calculs  virgule flottante
   //
   private static boolean ComparerMontants (final float Mt0, final float Mt1)
   {
      final float TOLRANCE = 0.01f;
      return Math.abs (Mt0 - Mt1) < TOLRANCE;
   }

   public Client (final String Nom, final String Prnom, final boolean Sexe,
                  final String Adresse)
      throws Exception
   {
      super (Nom, Prnom, Sexe);
      SetAdresse (Adresse);
      SetMontantEnSouffranceBrut (DETTE_DFAUT);
   }
   public Client (final String Nom, final String Prnom, final boolean Sexe,
                  final String Adresse, final float MontantEnSouffrance)
      throws Exception
   {
      super (Nom, Prnom, Sexe);
      SetAdresse (Adresse);
      SetMontantEnSouffrance (MontantEnSouffrance);
   }
   public Client (Client c)
   {
      super (c);
      SetAdresseBrut (c.GetAdresse ());
      SetMontantEnSouffranceBrut (c.GetMontantEnSouffrance ());
   }
   public Client copy (Client c)
   {
      super.copy (c);
      SetAdresseBrut (c.GetAdresse ());
      SetMontantEnSouffranceBrut (c.GetMontantEnSouffrance ());
      return this;
   }
   public boolean equals (Client c)
   {
      return super.equals (c) &&
             GetAdresse ().equals (c.GetAdresse ()) &&
             ComparerMontants (GetMontantEnSouffrance (),
                               c.GetMontantEnSouffrance ());
   }

}
