//
// Reprsente UN cours suivi par UN lve...
//

public class Cours
{
   private static final float
      NOTE_MIN = 0.0f,
      NOTE_MAX = 100.0f,
      NOTE_DFAUT = NOTE_MIN;

   private static final int
      NB_NOTES_DFAUT = 10; // arbitraire

   private String m_Nom;
   private float [] m_Notes;


   public String GetNom ()
   {
      return m_Nom;
   }
   private void SetNom (final String Nom)
      throws Exception
   {
      if (Nom == null)
         throw new Exception ("Nom nul (interdit)");
      SetNomBrut (Nom);
   }
   private void SetNomBrut (final String Nom)
   {
      m_Nom = Nom;
   }

   private void CrerNotes (final int NbNotes)
      throws Exception
   {
      if (NbNotes <= 0)
         throw new Exception ("Nombre de notes illgal (doit te positif)");
      CrerNotesBrut (NbNotes);
   }
   private void CrerNotesBrut (final int NbNotes)
   {
      m_Notes = new float [NbNotes];
      for (int i = 0; i < m_Notes.length; i++)
         m_Notes[i] = NOTE_DFAUT;
   }
   private void CopierNotes (final float [] Notes)
   {
      m_Notes = new float [Notes.length];
      for (int i = 0; i < m_Notes.length; i++)
         m_Notes[i] = Notes[i];
   }
   //
   // La comparaison de rels doit tenir compte des imprcisions
   // normales dans les calculs  virgule flottante
   //
   private static boolean ComparerNote (final float Note0, final float Note1)
   {
      final float TOLRANCE = 0.01f;
      return Math.abs (Note0 - Note1) < TOLRANCE;
   }
   private boolean ComparerNotes (final float [] Notes)
   {
      if (m_Notes.length != Notes.length)
         return false;

      for (int i = 0; i < m_Notes.length; i++)
         if (!ComparerNote (m_Notes[i], Notes[i]))
            return false;

      return true;
   }
   private float [] GetNotes ()
   {
      return m_Notes;
   }

   public Cours (final String Nom)
      throws Exception
   {
      SetNom (Nom);
      CrerNotesBrut (NB_NOTES_DFAUT);
   }
   public Cours (final String Nom, final int NbNotes)
      throws Exception
   {
      SetNom (Nom);
      CrerNotes (NbNotes);
   }
   public Cours (Cours Original)
   {
      SetNomBrut (Original.GetNom ());
      CopierNotes (Original.GetNotes ());
   }
   // Oprateurs
   public Cours copy (Cours c)
   {
      SetNomBrut (c.GetNom ());
      CopierNotes (c.GetNotes ());
      return this;
   }
   public boolean equals (Cours c)
   {
      return c != null &&
             GetNom ().equals (c.GetNom ()) &&
             GetNotes ().length == c.GetNotes ().length &&
             ComparerNotes (c.GetNotes ());
   }
}
