public class Personne
{
   private static final String
      NOM_DFAUT = "Blo",
      PRNOM_DFAUT = "Joe";
   private static final boolean
      SEXE_MASCULIN = false,
      SEXE_FMININ  = true,
      SEXE_DFAUT = SEXE_FMININ;

   public Personne ()
   {
      SetNomBrut (NOM_DFAUT);
      SetPrnomBrut (PRNOM_DFAUT);
      SetSexe (SEXE_DFAUT);
   }
   public Personne (final String Nom, final String Prnom,
                    final boolean Sexe)
      throws Exception
   {
      SetNom (Nom);
      SetPrnom (Prnom);
      SetSexe (Sexe);
   }
   public Personne (Personne Original)
   {
      SetNomBrut (Original.GetNom ());
      SetPrnomBrut (Original.GetPrnom ());
      SetSexe (Original.GetSexe ());
   }
   // Accesseurs
   public String GetNom ()
   {
      return m_Nom;
   }
   public String GetPrnom ()
   {
      return m_Prnom;
   }
   public boolean GetSexe ()
   {
      return m_Sexe;
   }
   // Manipulateurs
   public void SetNom (final String Nom)
      throws Exception
   {
      if (Nom == null)
         throw new Exception ("Nom nul (interdit)");
      SetNomBrut (Nom);
   }
   private void SetNomBrut (final String Nom)
   {
      m_Nom = Nom;
   }

   public void SetPrnom (final String Prnom)
      throws Exception
   {
      if (Prnom == null)
         throw new Exception ("Prnom nul (interdit)");
      SetPrnomBrut (Prnom);
   }
   private void SetPrnomBrut (final String Prnom)
   {
      m_Prnom = Prnom;
   }

   public void SetSexe (final boolean Sexe)
   {
      m_Sexe = Sexe;
   }
   // Oprateurs
   public Personne copy (Personne p)
   {
      SetNomBrut (p.GetNom ());
      SetPrnomBrut (p.GetPrnom ());
      SetSexe (p.GetSexe ());
      return this;
   }
   public boolean equals (Personne p)
   {
      return p != null &&
             GetNom ().equals (p.GetNom ()) &&
             GetPrnom ().equals (p.GetPrnom ()) &&
             GetSexe () == p.GetSexe ();
   }
   private String m_Prnom, m_Nom;
   private boolean m_Sexe;
}
